<?php
/**
 * Created by PhpStorm.
 * User: sdf_sky
 * Date: 2017/1/4
 * Time: 下午12:03
 */

namespace App\Services;

use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Log;
use Mrgoon\AliSms\AliSms;
use phpDocumentor\Reflection\Types\Self_;

class SmsService
{

   public static function sendSms($mobile,$smsTemplateId,$params){
       if(!config('services.sms_open')){
           return false;
       }
       if(!is_mobile($mobile) || !$smsTemplateId){
           return false;
       }
       return self::aliSmsSend($mobile,$smsTemplateId,$params);
   }


   public static function sendSmsCode($mobile){
       $code = random_number(6);
       Cache::put("sms_code_$mobile",$code,600);
       return self::sendSms($mobile,Setting()->get('sms_code_template'),['code'=>$code]);
   }


   public static function verifySmsCode($mobile,$code){
        $storeCode = Cache::get("sms_code_$mobile","");
        if($storeCode != $code){
            return false;
        }

       return true;
   }

   protected static function aliSmsSend($mobile,$smsTemplateId,$params){
       $response = Self::smsBaoSend($mobile, $smsTemplateId, $params);
       if($response != 0){
           Log::error("ali_sms_send_error".$response);
           return false;
       }
       return true;
   }

   protected static function smsBaoSend($mobile, $smsTemplateId, $params){
       $statusStr = array(
           "0" => "短信发送成功",
           "-1" => "参数不全",
           "-2" => "服务器空间不支持,请确认支持curl或者fsocket，联系您的空间商解决或者更换空间！",
           "30" => "密码错误",
           "40" => "账号不存在",
           "41" => "余额不足",
           "42" => "帐户已过期",
           "43" => "IP地址限制",
           "50" => "内容含有敏感词"
       );
       $smsapi = "http://api.smsbao.com/";
       $user = config('aliyunsms.access_key'); //短信平台帐号
       $pass = md5(config('aliyunsms.access_secret')); //短信平台密码
       $content= '【'.config('aliyunsms.sign_name').'】'.str_replace('${code}',$params['code'],$smsTemplateId);
       $phone = $mobile;//要发送短信的手机号码
       $sendurl = $smsapi."sms?u=".$user."&p=".$pass."&m=".$phone."&c=".urlencode($content);
       $result =file_get_contents($sendurl) ;
       if ($result != 0){
           return $statusStr[$result];
       }
       return $result;
   }

}